# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from . import utilities, tables

class AccountMember(pulumi.CustomResource):
    email_address: pulumi.Output[str]
    """
    The email address of the user who you wish to manage. Note: Following creation, this field becomes read only via the API and cannot be updated.
    """
    role_ids: pulumi.Output[list]
    """
    Array of account role IDs that you want to assign to a member.
    """
    def __init__(__self__, resource_name, opts=None, email_address=None, role_ids=None, __name__=None, __opts__=None):
        """
        Provides a resource which manages Cloudflare account members.
        
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] email_address: The email address of the user who you wish to manage. Note: Following creation, this field becomes read only via the API and cannot be updated.
        :param pulumi.Input[list] role_ids: Array of account role IDs that you want to assign to a member.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if not resource_name:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(resource_name, str):
            raise TypeError('Expected resource name to be a string')
        if opts and not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if email_address is None:
            raise TypeError("Missing required property 'email_address'")
        __props__['email_address'] = email_address

        if role_ids is None:
            raise TypeError("Missing required property 'role_ids'")
        __props__['role_ids'] = role_ids

        super(AccountMember, __self__).__init__(
            'cloudflare:index/accountMember:AccountMember',
            resource_name,
            __props__,
            opts)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

