# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from . import utilities, tables

class Zone(pulumi.CustomResource):
    jump_start: pulumi.Output[bool]
    """
    Boolean of whether to scan for DNS records on creation. Ignored after zone is created. Default: false.
    """
    meta: pulumi.Output[dict]
    name_servers: pulumi.Output[list]
    """
    Cloudflare-assigned name servers. This is only populated for zones that use Cloudflare DNS.
    """
    paused: pulumi.Output[bool]
    """
    Boolean of whether this zone is paused (traffic bypasses Cloudflare). Default: false.
    """
    plan: pulumi.Output[str]
    """
    The name of the commercial plan to apply to the zone, can be updated once the one is created; one of `free`, `pro`, `business`, `enterprise`.
    """
    status: pulumi.Output[str]
    """
    Status of the zone. Valid values: `active`, `pending`, `initializing`, `moved`, `deleted`, `deactivated`.
    """
    type: pulumi.Output[str]
    """
    A full zone implies that DNS is hosted with Cloudflare. A partial zone is typically a partner-hosted zone or a CNAME setup. Valid values: `full`, `partial`. Default is `full`.
    """
    vanity_name_servers: pulumi.Output[list]
    """
    List of Vanity Nameservers (if set).
    * `meta.wildcard_proxiable` - Indicates whether wildcard DNS records can receive Cloudflare security and performance features.
    * `meta.phishing_detected` - Indicates if URLs on the zone have been identified as hosting phishing content.
    """
    zone: pulumi.Output[str]
    """
    The DNS zone name which will be added.
    """
    def __init__(__self__, resource_name, opts=None, jump_start=None, paused=None, plan=None, type=None, zone=None, __name__=None, __opts__=None):
        """
        Provides a Cloudflare Zone resource. Zone is the basic resource for working with Cloudflare and is roughly equivalent to a domain name that the user purchases.
        
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] jump_start: Boolean of whether to scan for DNS records on creation. Ignored after zone is created. Default: false.
        :param pulumi.Input[bool] paused: Boolean of whether this zone is paused (traffic bypasses Cloudflare). Default: false.
        :param pulumi.Input[str] plan: The name of the commercial plan to apply to the zone, can be updated once the one is created; one of `free`, `pro`, `business`, `enterprise`.
        :param pulumi.Input[str] type: A full zone implies that DNS is hosted with Cloudflare. A partial zone is typically a partner-hosted zone or a CNAME setup. Valid values: `full`, `partial`. Default is `full`.
        :param pulumi.Input[str] zone: The DNS zone name which will be added.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if not resource_name:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(resource_name, str):
            raise TypeError('Expected resource name to be a string')
        if opts and not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        __props__['jump_start'] = jump_start

        __props__['paused'] = paused

        __props__['plan'] = plan

        __props__['type'] = type

        if zone is None:
            raise TypeError("Missing required property 'zone'")
        __props__['zone'] = zone

        __props__['meta'] = None
        __props__['name_servers'] = None
        __props__['status'] = None
        __props__['vanity_name_servers'] = None

        super(Zone, __self__).__init__(
            'cloudflare:index/zone:Zone',
            resource_name,
            __props__,
            opts)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

